#!/bin/sh

if [ $# -ne 1 ] ; then
	echo "Usage: $0 <version>" >&2
	exit 1
fi

case "$1" in
	v*)
		version="`echo $1 | cut -c 2-`"
		tag="$1"
		;;
	*)
		version="$1"
		tag="v$1"
		;;
esac

echo "version = '$version'"
echo "ok?"
read n

set -x

hg tag -f -e $tag
hg sign -e .

mkdir -p archive
cd archive
hg archive -p hlog-${version}/ -t tgz -r . hlog-${version}.tar.gz
gpg -a --detach-sign hlog-${version}.tar.gz
rm -f latest.tar.gz latest.tar.gz.asc
ln -s hlog-${version}.tar.gz latest.tar.gz
ln -s hlog-${version}.tar.gz.asc latest.tar.gz.asc
